/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	Pages
**
** DESCRIPTION:	Story pages
**
**      AUTHOR:	Adrian Francis
**
\******************************************************************************/

#ifndef PAGES_H
#define PAGES_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "PageInterface.h"

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class CIntroPage1 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;
	int			m_iTimer;

	//class methods
	//process
	public:		void Enter();
	public:		void Exit();
	public:		const bool FadeImage();
	public:		const bool FadeOut();
};

class CIntroPage2 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;
	int			m_iTimer;

	//class methods
	//process
	public:		void Enter();
	public:		void Exit();
	public:		const bool FadeImage();
	public:		const bool FadeOut();
};

class CIntroPage3 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;

	//class methods
	//process
	public:		void Enter();
	public:		const bool FadeImage();
	public:		const bool FadeOut();
};

class CIntroPage4 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;

	//class methods
	//process
	public:		void Enter();
	public:		const bool FadeImage();
	public:		const bool FadeOut();
};

class CIntroPage5 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;
	int			m_iMaskingImage;

	int			m_iFrame;

	//class methods
	//process
	public:		void Enter();
	public:		void Exit();
	public:		const bool FadeImage();
	public:		void FadeImageSkipped();
	public:		void Update();
	public:		const bool FadeOut();
};

class CMidGamePage1 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;
	int			m_iMaskingImage;

	int			m_iFrame;

	//class methods
	//process
	public:		void Enter();
	public:		const bool FadeImage();
	public:		void Update();
	public:		const bool FadeOut();
};

class CMidGamePage2 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;

	//class methods
	//process
	public:		void Enter();
	public:		const bool FadeImage();
	public:		const bool FadeOut();
};

class CMidGamePage3 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;
	int			m_iFishAndPlantImage[12];

	int			m_iFrame;

	//class methods
	//process
	public:		void Enter();
	public:		const bool FadeImage();
	public:		void Update();
	public:		const bool FadeOut();
};

class CEndGamePage1 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;
	int			m_iMaskingImage;

	int			m_iFrame;

	//class methods
	//process
	public:		void Enter();
	public:		const bool FadeImage();
	public:		void Update();
	public:		const bool FadeOut();
};

class CEndGamePage2 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;

	//class methods
	//process
	public:		void Enter();
	public:		const bool FadeImage();
	public:		const bool FadeOut();
};

class CEndGamePage3 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;

	//class methods
	//process
	public:		void Enter();
	public:		const bool FadeImage();
	public:		const bool FadeOut();
};

class CEndGamePage4 : public IPage
{
private:

	//class data
	int			m_iBackgroundImage;

	//class methods
	//process
	public:		void Enter();
	public:		const bool FadeImage();
	public:		const bool FadeOut();
};

/******************************************************************************\
** GLOBAL DECLARATIONS
\******************************************************************************/
extern CIntroPage1		IntroPage1;
extern CIntroPage2		IntroPage2;
extern CIntroPage3		IntroPage3;
extern CIntroPage4		IntroPage4;
extern CIntroPage5		IntroPage5;
extern CMidGamePage1	MidGamePage1;
extern CMidGamePage2	MidGamePage2;
extern CMidGamePage3	MidGamePage3;
extern CEndGamePage1	EndGamePage1;
extern CEndGamePage2	EndGamePage2;
extern CEndGamePage3	EndGamePage3;
extern CEndGamePage4	EndGamePage4;

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/